<template>
  <div>
    <!-- <gz-report-selector ref="reportSelector"></gz-report-selector> -->
    <div v-if="formState.ready">
      <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
      <gz-alert
        :alert-message="$store.state.globalSettings.csrInfoText"
      ></gz-alert>
      <v-form ref="form">
        <v-row dense>
          <v-col
            v-if="$store.state.userType == 4"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-pick-list
              ref="customerId"
              v-model="obj.customerId"
              :aya-type="ayaTypes().Customer"
              show-edit-icon
              :include-inactive="true"
              :label="$ay.t('Customer')"
              data-cy="customerId"
              variant="ho"
              template="[{'fld':'customername'}]"
              @input="fieldValueChanged('customerId')"
            ></gz-pick-list>
          </v-col>
          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-select
              ref="priority"
              v-model="obj.priority"
              dense
              :color="priorityColor()"
              :item-color="priorityColor()"
              :items="selectLists.priorities"
              item-text="name"
              item-value="id"
              :label="$ay.t('CustomerServiceRequestPriority')"
              data-cy="priority"
              append-icon=""
              @input="fieldValueChanged('priority')"
            >
              <template v-slot:prepend
                ><v-icon :color="priorityColor()"> $ayiCircle </v-icon>
              </template></v-select
            >
          </v-col>

          <v-col
            v-if="
              form().showMe(
                this,
                'CustomerServiceRequestCustomerReferenceNumber'
              )
            "
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-text-field
              ref="customerReferenceNumber"
              v-model="obj.customerReferenceNumber"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('CustomerServiceRequestCustomerReferenceNumber')"
              data-cy="customerReferenceNumber"
              :error-messages="
                form().serverErrors(this, 'customerReferenceNumber')
              "
              @input="fieldValueChanged('customerReferenceNumber')"
            ></v-text-field>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'CustomerServiceRequestItemUnitID')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-pick-list
              ref="unitId"
              v-model="obj.unitId"
              :aya-type="ayaTypes().Unit"
              :variant="unitListVariant()"
              template="[
                { fld: 'UnitSerial' },
                { fld: 'UnitModelName' },
                { fld: 'UnitModelVendorID' }
              ]"
              :readonly="formState.readOnly"
              :label="$ay.t('CustomerServiceRequestItemUnitID')"
              data-cy="unitId"
              :error-messages="form().serverErrors(this, 'unitId')"
              @input="fieldValueChanged('unitId')"
            ></gz-pick-list>
          </v-col>
          <v-col
            v-if="$store.state.customerRights.createUnit == true"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-btn @click="showAddUnitDialog()">{{
              $ay.t("AddNewUnit")
            }}</v-btn>
          </v-col>

          <v-col cols="12">
            <v-text-field
              ref="name"
              v-model="obj.name"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('CustomerServiceRequestTitle')"
              :rules="[form().required(this, 'name')]"
              :error-messages="form().serverErrors(this, 'name')"
              data-cy="name"
              @input="fieldValueChanged('name')"
            ></v-text-field>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'CustomerServiceRequestDetails')"
            cols="12"
          >
            <v-textarea
              ref="notes"
              v-model="obj.notes"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('CustomerServiceRequestDetails')"
              :error-messages="form().serverErrors(this, 'notes')"
              data-cy="notes"
              auto-grow
              @input="fieldValueChanged('notes')"
            ></v-textarea>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <gz-date-picker
              ref="dateRequested"
              v-model="obj.dateRequested"
              :label="$ay.t('Created')"
              readonly
              data-cy="dateRequested"
            ></gz-date-picker>
          </v-col>
          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-select
              ref="status"
              v-model="obj.status"
              dense
              :items="selectLists.status"
              item-text="name"
              item-value="id"
              readonly
              :label="$ay.t('CustomerServiceRequestStatus')"
              data-cy="status"
              append-icon=""
            ></v-select>
          </v-col>
        </v-row>
      </v-form>
      <!-- ################################################################################-->
      <!-- ##########################  UNIT ADD FORM  #####################################-->
      <!-- ################################################################################-->
      <template>
        <v-row dense justify="center">
          <v-dialog v-model="addUnitDialog" max-width="1600px">
            <v-card>
              <v-card-title> </v-card-title>
              <v-card-text>
                <v-row dense>
                  <!-- <v-col
                    v-if="$store.state.userType == 4"
                    cols="12"
                    sm="6"
                    lg="4"
                    xl="3"
                  >
                    <gz-pick-list
                      :aya-type="ayaTypes().Customer"
                      show-edit-icon
                      :include-inactive="true"
                      v-model="unitObj.customerId"
                      :label="$ay.t('Customer')"
                      ref="customerId"
                      data-cy="customerId"
                      variant="ho"
                      template="[{'fld':'customername'}]"
                    ></gz-pick-list>
                  </v-col> -->
                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <v-text-field
                      ref="serial"
                      v-model="unitObj.serial"
                      dense
                      :readonly="formState.readOnly"
                      :label="$ay.t('UnitSerial')"
                      :rules="[form().required(this, 'serial')]"
                      :error-messages="form().serverErrors(this, 'serial')"
                      data-cy="serial"
                      @input="fieldValueChanged('serial')"
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <v-text-field
                      ref="description"
                      v-model="unitObj.description"
                      dense
                      :readonly="formState.readOnly"
                      :label="$ay.t('UnitDescription')"
                      data-cy="description"
                      :error-messages="form().serverErrors(this, 'description')"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <gz-pick-list
                      ref="unitModelId"
                      v-model="unitObj.unitModelId"
                      :aya-type="ayaTypes().UnitModel"
                      template="[{ fld: 'UnitModelName' },{ fld: 'UnitModelVendorID' }]"
                      show-edit-icon
                      :readonly="formState.readOnly"
                      :label="$ay.t('UnitModel')"
                      data-cy="unitModelId"
                      :error-messages="form().serverErrors(this, 'unitModelId')"
                    ></gz-pick-list>
                  </v-col>
                </v-row>
              </v-card-text>
              <v-card-actions>
                <v-btn text color="primary" @click="addUnitDialog = false">{{
                  $ay.t("Cancel")
                }}</v-btn>
                <v-spacer></v-spacer>
                <v-btn
                  :disabled="unitObj.serial == null"
                  color="primary"
                  text
                  class="ml-4"
                  data-cy="csrUnitAdd"
                  @click="addUnit()"
                  >{{ $ay.t("Add") }}</v-btn
                >
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-row>
      </template>
    </div>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "customer-csr-edit";
const API_BASE_URL = "csr/";
const FORM_CUSTOM_TEMPLATE_KEY = "CustomerServiceRequest";
export default {
  data() {
    return {
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      selectedWOId: 0,
      woSelectorDialog: false,
      selectLists: {
        status: [],
        priorities: []
      },
      obj: {
        id: 0,
        concurrency: 0,
        name: null,
        active: true,
        notes: null,
        wiki: null,
        customFields: "{}",
        tags: [],
        dateRequested: window.$gz.locale.nowUTC8601String(),
        customerId: null,
        unitId: null,
        workOrderItemId: null,
        requestedByUserId: this.$store.state.userId,
        customerReferenceNumber: null,
        status: 0,
        priority: 0
      },
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      ayaType: window.$gz.type.CustomerServiceRequest,
      addUnitDialog: false,
      unitObj: {
        serial: null,
        description: null,
        unitModelId: null,
        customerId: null
      }
    };
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }
        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }
        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);

      vm.rights = window.$gz.role.getRights(
        window.$gz.type.CustomerServiceRequest
      );
      vm.formState.readOnly = !vm.rights.change || vm.obj.status != 0;
      window.$gz.eventBus.$on("menu-click", clickHandler);

      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
          window.$gz.form.setFormState({
            vm: vm,
            loading: false
          });
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        //NEW
        //
        if (this.$store.state.userType == 3) {
          //Customer specific user
          this.obj.customerId = this.$store.state.customerRights.entityId;
          this.unitObj.customerId = this.$store.state.customerRights.entityId;
        }
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
      window.$gz.form.setFormState({
        vm: vm,
        dirty: false,
        valid: true
      });

      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    showAddUnitDialog: function() {
      this.unitObj.customerId = this.obj.customerId;
      this.addUnitDialog = true;
    },
    async addUnit() {
      const vm = this;
      if (!vm.unitObj.serial) {
        return;
      }
      try {
        const res = await window.$gz.api.upsert(
          "unit/customerunit/",
          vm.unitObj
        );
        if (res.error) {
          //no vm passed here so that it displays as a dialog rather than in the form
          window.$gz.errorHandler.handleFormError(res.error);
        } else {
          if (res.data) {
            if (vm.obj.unitId == null) {
              vm.obj.unitId = res.data;
              // this.formState.dirty = true;
            }
            //SUCCESS
            this.addUnitDialog = false;
          }
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex); //no vm passed here so that it displays as a dialog rather than in the form
      }
    },
    unitListVariant: function() {
      return `customerid: ${this.obj.customerId}`;
    },
    priorityColor: function() {
      switch (this.obj.priority) {
        case 1: //asap
          return "warning";
        case 2: //emergency
          return "error";
        default:
          return "success";
      }
    },
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    ayaTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false
          });
          vm.formState.readOnly = !vm.rights.change || vm.obj.status != 0;
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }
      try {
        window.$gz.form.setFormState({
          vm: vm,
          loading: true
        });
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.replace({
              name: "customer-csr-edit",
              params: {
                recordid: res.data.id,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        window.$gz.form.setFormState({
          vm: this,
          loading: true
        });
        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;
          this.$router.go(-1);
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(
            API_BASE_URL + this.$route.params.recordid
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, this);
      } finally {
        window.$gz.form.setFormState({
          vm: this,
          loading: false
        });
      }
    },
    async reject() {
      const vm = this;
      if (vm.obj.status != 0 || vm.$route.params.recordid == 0) {
        return;
      }
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      const url = API_BASE_URL + "reject/" + vm.$route.params.recordid;
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(url);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          this.$router.push({
            name: "csr-edit",
            params: {
              recordid: res.data.id,
              obj: res.data
            }
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async accept(toExistingId) {
      const vm = this;
      if (vm.obj.status != 0 || vm.$route.params.recordid == 0) {
        return;
      }
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      //get workorder if to existing
      const url = `${API_BASE_URL}accept/${vm.$route.params.recordid}/${toExistingId}`;
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(url);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          this.$router.push({
            name: "csr-edit",
            params: {
              recordid: res.data.id,
              obj: res.data
            }
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "delete":
        m.vm.remove();
        break;

      case "reject":
        m.vm.reject();
        break;
      case "acceptexisting":
        m.vm.woSelectorDialog = true;
        break;
      case "acceptnew":
        m.vm.accept(0);
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly || vm.obj.status != 0,
    icon: "$ayiConciergeBell",
    title: "CustomerServiceRequest",
    helpUrl: "customer-csr",
    hideSearch: true,
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$ayiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  if (
    vm.rights.delete &&
    vm.$route.params.recordid != 0 &&
    !vm.formState.readOnly
  ) {
    menuOptions.menuItems.push({
      title: "Delete",
      icon: "$ayiTrashAlt",
      surface: false,
      key: FORM_KEY + ":delete",
      vm: vm
    });
  }

  menuOptions.menuItems.push({ divider: true, inset: false });
  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await fetchTranslatedText();
  await window.$gz.formCustomTemplate.get(FORM_CUSTOM_TEMPLATE_KEY, vm);
  await populateSelectionLists(vm);
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "CustomerServiceRequest",
    "CustomerServiceRequestAcceptToNew",
    "CustomerServiceRequestAcceptToExisting",
    "CustomerServiceRequestReject",
    "CustomerServiceRequestTitle",
    "CustomerServiceRequestDetails",
    "Created",
    "Customer",
    "CustomerServiceRequestItemUnitID",
    "WorkOrder",
    "CustomerServiceRequestRequestedBy",
    "CustomerServiceRequestCustomerReferenceNumber",
    "CustomerServiceRequestStatus",
    "CustomerServiceRequestPriority",
    "CustomerServiceRequestCustom1",
    "CustomerServiceRequestCustom2",
    "CustomerServiceRequestCustom3",
    "CustomerServiceRequestCustom4",
    "CustomerServiceRequestCustom5",
    "CustomerServiceRequestCustom6",
    "CustomerServiceRequestCustom7",
    "CustomerServiceRequestCustom8",
    "CustomerServiceRequestCustom9",
    "CustomerServiceRequestCustom10",
    "CustomerServiceRequestCustom11",
    "CustomerServiceRequestCustom12",
    "CustomerServiceRequestCustom13",
    "CustomerServiceRequestCustom14",
    "CustomerServiceRequestCustom15",
    "CustomerServiceRequestCustom16",
    "AddNewUnit",
    "UnitDescription",
    "UnitModel",
    "UnitSerial"
  ]);
}

//////////////////////
//
//
async function populateSelectionLists(vm) {
  //ensure the pick lists required are pre-fetched
  await window.$gz.enums.fetchEnumList("CustomerServiceRequestStatus");
  vm.selectLists.status = window.$gz.enums.getSelectionList(
    "CustomerServiceRequestStatus"
  );

  await window.$gz.enums.fetchEnumList("CustomerServiceRequestPriority");
  vm.selectLists.priorities = window.$gz.enums.getSelectionList(
    "CustomerServiceRequestPriority"
  );
}
</script>
